#include <iostream>
#include <cmath>

//projekt: obvod a obsah ctyruhelniku, uhel je zadan v radianech - jazyk C neumí uhlove stupne!!!!!

using namespace std;


class ctyruhelnik
{
protected:
	double m_a;
	double m_b;
	double m_c;
	double m_d;
public:
	ctyruhelnik(double a, double b, double c, double d): m_a(a),
							     m_b(b),	
							     m_c(c),
							     m_d(d)
	{
		if ((a<=0)||(b<=0)||(c<=0)||(d<=0)) throw "Chyba: nekladna delka strany.";
	}

	double obvod (void)
	{
		return m_a+m_b+m_c+m_d;
	}
	
};


class rovnobeznik: public ctyruhelnik
{
protected:
	double m_uhel;	//doplneni dalsiho atributu
public:
	rovnobeznik(double a, double b, double uhel): ctyruhelnik(a, b, a, b),		//strana "a" a "b" jsou rovnobezne
						      m_uhel(uhel)			//uhel sevreny stranou "a" a "b"
	{}

	double obsah (void)
	{
		return m_a*m_b*sin(m_uhel);
	}
};


class obdelnik: public rovnobeznik
{
public:
	obdelnik(double a, double b): rovnobeznik(a, b, M_PI/2) //uhel v radianech 90 stupnu = M_PI/2
	{}

	double obsah (void)
	{
		return m_a*m_b;
	}
};


class ctverec: public obdelnik
{
public:
	ctverec(double a): obdelnik(a, a)
	{}

};

class lichobeznik: public ctyruhelnik
{
public:
	lichobeznik(double a, double b, double c, double d, double vyska): ctyruhelnik(a, b, c, d),   //rovnobezne strany jsou "a" a "c"
			   					           m_vyska(vyska)
	{
 		if (vyska<=0) throw "Chyba: nekladna vyska.";
	}

	double obsah (void)
	{
		return m_vyska*(m_a+m_c)*0.5;
	}

protected:
	double m_vyska;
};

int main (void)
{
	ctyruhelnik x1(1.0, 2.0, 3.0, 4.0);	//vkladame vstupni hodnoty 1,2,3,4
	rovnobeznik x2(4.0, 5.0, M_PI/4);	//uhel v radianech 90 stupnu = M_PI/4, M_PI je konstata v math knihovne C
	obdelnik x3(6.0, 7.0);
	ctverec x4(8.0);
	lichobeznik x5(4.0, 6.0, 8.0, 5.0, 4.5);
	cout<<"Obvod ctyruhelniku je "<<x1.obvod()<<endl;
	cout<<"Obvod rovnobezniku je "<<x2.obvod()<<", obsah rovnbezniku je "<<x2.obsah()<<endl;
	cout<<"Obvod obdelniku je "<<x3.obvod()<<", obsah obdelniku je "<<x3.obsah()<<endl;
	cout<<"Obvod ctverce je "<<x4.obvod()<<", obsah ctverce je "<<x4.obsah()<<endl;
	cout<<"Obvod lichobezniku je "<<x5.obvod()<<", obsah lichobezniku je "<<x5.obsah()<<endl;
	x2=x4;
	cout<<"Obvod ctverce je "<<x2.obvod()<<", obsah ctverce je "<<x2.obsah()<<endl;	//ctverec pocitame z rovnobezniku!
	return 0;
}



